--
-- Common MySQL stuff
--

USEC = require( "ffi" )
USEC.cdef( "int usleep(int microseconds);" )


function mysql_check_charset( con )
  if( sysbench.tid == 0 and sysbench.opt.mysql_check_charset ) then
    local rs

    rs = con:query( [[
      SELECT * FROM performance_schema.session_variables
        WHERE VARIABLE_NAME IN (
          'character_set_client', 'character_set_connection',
          'character_set_results', 'collation_connection'
        ) ORDER BY VARIABLE_NAME;
    ]] )

    print( "\nCheck MySQL Connection charset" )
    print( "------------------------------------------------------------------" )

    for i = 1, rs.nrows
    do
      row = rs:fetch_row()
      print( string.format( " %-30s : %s", row[1], row[2] ))
    end

    print( "------------------------------------------------------------------\n" )
  end
end


function mysql_session_opt( con )
  local my

  if( string.len( sysbench.opt.mysql_session_options ) > 0 ) then
    my= sysbench.opt.mysql_session_options
  else
    my= os.getenv( "MYSQL_SESSION_OPTIONS" )
    if( my == nil ) then
      mysql_check_charset( con )
      return(-1)
    end

    sysbench.opt.mysql_session_options = my
  end

  local i = 0
  local j = 1

  while true do
    i= string.find( my, ";", i+1 )
    if( i == nil ) then
      break
    end

    con:query( string.sub( my, j, i ))
    j=i+1
  end

  if( j < string.len(my)) then
    con:query( string.sub( my, j ) .. ";" )
  end

  mysql_check_charset( con )
  return(0)
end

